Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90	(revision 5075)
@@ -1610,173 +1497,186 @@
       ! local variable
       INTEGER(i4)                       :: il_status
-      INTEGER(i4)                       :: il_tmp1, il_tmp2, il_varid
+      INTEGER(i4)                       :: il_tmp1
+      INTEGER(i4)                       :: il_tmp2
+      INTEGER(i4)                       :: il_varid
       INTEGER(i4), DIMENSION(ip_maxdim) :: il_start
       INTEGER(i4), DIMENSION(ip_maxdim) :: il_count
       INTEGER(i4), DIMENSION(ip_maxdim) :: il_start_ord
       INTEGER(i4), DIMENSION(ip_maxdim) :: il_count_ord
-      REAL(dp)   , DIMENSION(:,:,:,:), ALLOCATABLE :: dl_value
-
-      TYPE(TDIM),  DIMENSION(ip_maxdim) :: tl_dim
+      REAL(dp)   , DIMENSION(:,:,:,:)  , ALLOCATABLE :: dl_value
+      REAL(dp)   , DIMENSION(:,:,:,:)  , ALLOCATABLE :: dl_tmp
+
       ! loop indices
       INTEGER(i4) :: ji
       !----------------------------------------------------------------
 
-      ! check id_count and id_start optionals parameters...
-      IF( (       PRESENT(id_start)  .AND. (.NOT. PRESENT(id_count))) .OR. &
-          ((.NOT. PRESENT(id_start)) .AND.        PRESENT(id_count) ) )THEN
-         CALL logger_warn( &
-         &  " READ VAR VALUE: id_start and id_count should be both specify")
-      ENDIF
-
-      IF( PRESENT(id_start).AND.PRESENT(id_count) )THEN
-
-         IF( SIZE(id_start(:)) /= ip_maxdim .OR. &
-         &   SIZE(id_count(:)) /= ip_maxdim )THEN
-            CALL logger_error("READ VAR: dimension of table start or count "//&
-            &      " are invalid to read variable "//TRIM(td_var%c_name)//&
-            &      " in file "//TRIM(td_file%c_name) )
-         ENDIF
-
-         ! change dimension order from ('x','y','z','t')
-         il_start(:)=dim_reorder_xyzt2(td_var%t_dim, id_start(:))
-         il_count(:)=dim_reorder_xyzt2(td_var%t_dim, id_count(:))
-
-         ! keep ordered table ('x','y','z','t')
-         il_start_ord(:)=il_start(:)
-         il_count_ord(:)=il_count(:)
-
+      ! check if variable in file structure
+      il_varid=var_get_id(td_file%t_var(:),TRIM(td_var%c_name))
+      IF( il_varid /= 0 )THEN
+
+         ! check id_count and id_start optionals parameters...
+         IF( (       PRESENT(id_start)  .AND. (.NOT. PRESENT(id_count))) .OR. &
+             ((.NOT. PRESENT(id_start)) .AND.        PRESENT(id_count) ) )THEN
+            CALL logger_warn( &
+            &  "IOM CDF READ VAR VALUE: id_start and id_count should be both specify")
+         ENDIF
+         IF( PRESENT(id_start).AND.PRESENT(id_count) )THEN
+
+            IF( SIZE(id_start(:)) /= ip_maxdim .OR. &
+            &   SIZE(id_count(:)) /= ip_maxdim )THEN
+               CALL logger_error("IOM CDF READ VAR: dimension of array start or count "//&
+               &      " are invalid to read variable "//TRIM(td_var%c_name)//&
+               &      " in file "//TRIM(td_file%c_name) )
+            ENDIF
+
+            ! change dimension order from ('x','y','z','t')
+            il_start(:)=dim_reorder_xyzt2(td_var%t_dim, id_start(:))
+            il_count(:)=dim_reorder_xyzt2(td_var%t_dim, id_count(:))
+
+            ! keep ordered array ('x','y','z','t')
+            il_start_ord(:)=id_start(:)
+            il_count_ord(:)=id_count(:)
+
+         ELSE
+
+            ! change dimension order from ('x','y','z','t')
+            il_start(:)=(/1,1,1,1/)
+            il_count(:)=dim_reorder_xyzt2(td_var%t_dim(:),td_var%t_dim(:)%i_len)
+
+            ! keep ordered array ('x','y','z','t')
+            il_start_ord(:)=(/1,1,1,1/)
+            il_count_ord(:)=td_var%t_dim(:)%i_len
+
+         ENDIF
+
+         ! check dimension
+         IF( .NOT. ALL(il_start_ord(:)>=(/1,1,1,1/)) )THEN
+
+            CALL logger_error( "IOM CDF READ VAR VALUE: start indices should"//&
+            &  " be greater than or equal to 1")
+
+         ENDIF
+
+         IF(.NOT.ALL(il_start_ord(:)+il_count_ord(:)-1 <= &
+            &  (/td_var%t_dim( 1 )%i_len,&
+            &    td_var%t_dim( 2 )%i_len,&
+            &    td_var%t_dim( 3 )%i_len,&
+            &    td_var%t_dim( 4 )%i_len &
+            &                                            /)) )THEN
+
+            CALL logger_error( "IOM CDF READ VAR VALUE: start + count exceed "//&
+            &  "variable dimension for "//TRIM(td_var%c_name) )
+
+            DO ji = 1, ip_maxdim
+               il_tmp1=il_start_ord(ji)+il_count_ord(ji)-1
+               il_tmp2=td_var%t_dim(ji)%i_len
+               CALL logger_debug( "IOM CDF READ VAR VALUE: start + count -1:"//&
+               &  TRIM(fct_str(il_tmp1))//" variable dimension"//&
+               &  TRIM(fct_str(il_tmp2)))
+            ENDDO
+
+         ELSE
+
+            ! Allocate space to hold variable value (unorder)
+            ALLOCATE(dl_value( il_count(1), &
+               &               il_count(2), &
+               &               il_count(3), &
+               &               il_count(4)),&
+               &               stat=il_status)
+            IF( il_status /= 0 )THEN
+
+              CALL logger_error( &
+               &  "IOM CDF READ VAR VALUE: not enough space to put variable "//&
+               &  TRIM(td_var%c_name))
+
+            ENDIF
+
+            ! read values
+            CALL logger_debug( &
+            &  "IOM CDF READ VAR VALUE: get variable "//TRIM(td_var%c_name)//&
+            &  " in file "//TRIM(td_file%c_name))
+
+            il_status = NF90_GET_VAR( td_file%i_id, il_varid,           &
+            &                                       dl_value(:,:,:,:),  &
+            &                                       start = il_start(:),&
+            &                                       count = il_count(:) )
+            CALL iom_cdf__check(il_status)
+
+            ! Allocate space to hold variable value in structure
+            IF( ASSOCIATED(td_var%d_value) )THEN
+               DEALLOCATE(td_var%d_value)   
+            ENDIF
+  
+            ! new dimension length
+            td_var%t_dim(:)%i_len=il_count_ord(:)
+
+!>   dummy patch for pgf95
+            ALLOCATE( dl_tmp( td_var%t_dim(1)%i_len, &
+            &                 td_var%t_dim(2)%i_len, &
+            &                 td_var%t_dim(3)%i_len, &
+            &                 td_var%t_dim(4)%i_len),&
+            &        stat=il_status)
+            IF(il_status /= 0 )THEN
+
+               CALL logger_error( &
+               &  "IOM CDF READ VAR VALUE: not enough space to put variable "//&
+               &  TRIM(td_var%c_name)//&
+               &  " in variable structure")
+            ENDIF
+            dl_tmp(:,:,:,:)=td_var%d_fill
+
+            ! reshape values to be ordered as ('x','y','z','t')
+            dl_tmp(:,:,:,:)=dim_reshape_2xyzt(td_var%t_dim(:), &
+            &                                 dl_value(:,:,:,:))
+
+            DEALLOCATE(dl_value)
+
+            ALLOCATE(td_var%d_value( td_var%t_dim(1)%i_len, &
+            &                        td_var%t_dim(2)%i_len, &
+            &                        td_var%t_dim(3)%i_len, &
+            &                        td_var%t_dim(4)%i_len),&
+            &        stat=il_status)
+            IF(il_status /= 0 )THEN
+
+               CALL logger_error( &
+               &  "IOM CDF READ VAR VALUE: not enough space to put variable "//&
+               &  TRIM(td_var%c_name)//&
+               &  " in variable structure")
+
+            ENDIF
+!            ! FillValue by default
+!            td_var%d_value(:,:,:,:)=td_var%d_fill
+!
+!            ! reshape values to be ordered as ('x','y','z','t')
+!            td_var%d_value(:,:,:,:)=dim_reshape_2xyzt(td_var%t_dim(:), &
+!            &                                         dl_value(:,:,:,:))
+!
+!            DEALLOCATE(dl_value)
+
+            td_var%d_value(:,:,:,:)=dl_tmp(:,:,:,:)
+            DEALLOCATE(dl_tmp)
+!<   dummy patch for pgf95
+
+            ! force to change _FillValue to avoid mistake 
+            ! with dummy zero _FillValue
+            IF( td_var%d_fill == 0._dp )THEN
+               CALL var_chg_FillValue(td_var)
+            ENDIF
+         ENDIF
       ELSE
-
-         ! change dimension order from ('x','y','z','t')
-         il_start(:)=(/1,1,1,1/)
-         il_count(:)=dim_reorder_xyzt2(td_var%t_dim(:),td_var%t_dim(:)%i_len)
-
-         ! keep ordered table ('x','y','z','t')
-         il_start_ord(:)=(/1,1,1,1/)
-         il_count_ord(:)=td_var%t_dim(:)%i_len
-
-      ENDIF
-
-      ! check dimension
-      IF( .NOT. ALL(il_start_ord(:)>=(/1,1,1,1/)) )THEN
-
          CALL logger_error( &
-         &" READ VAR VALUE: start indices should be greater than or equal to 1")
-
-      ENDIF
-
-      IF(.NOT.ALL(il_start_ord(:)+il_count_ord(:)-1<=(/td_var%t_dim(1)%i_len,&
-         &                                             td_var%t_dim(2)%i_len,&
-         &                                             td_var%t_dim(3)%i_len,&
-         &                                             td_var%t_dim(4)%i_len &
-         &                                            /)) )THEN
-
-         CALL logger_error( &
-         &  " READ VAR VALUE: start + count exceed variable dimension" )
-
-         DO ji = 1, ip_maxdim
-            il_tmp1=il_start_ord(ji)+il_count_ord(ji)
-            il_tmp2=td_var%t_dim(ji)%i_len
-            CALL logger_debug( &
-            &  " READ VAR VALUE: start + count -1 "//TRIM(fct_str(il_tmp1))//&
-            &  " variable dimension"//TRIM(fct_str(il_tmp2)))
-         ENDDO
-
-      ELSE
-
-         ! Allocate space to hold variable value (unorder)
-         ALLOCATE(dl_value( il_count(1), &
-            &               il_count(2), &
-            &               il_count(3), &
-            &               il_count(4)),&
-            &               stat=il_status)
-         IF( il_status /= 0 )THEN
-
-           CALL logger_error( &
-            &  " READ VAR VALUE: not enough space to put variable "//&
-            &  TRIM(td_var%c_name))
-
-         ENDIF
-
-         ! read values
-         CALL logger_debug( &
-         &  " READ VAR VALUE: get variable "//TRIM(td_var%c_name)//&
-         &  " in file "//TRIM(td_file%c_name))
-         CALL logger_debug("start "//TRIM(fct_str(il_start(1)))//','//&
-         &                           TRIM(fct_str(il_start(2)))//','//&
-         &                           TRIM(fct_str(il_start(3)))//','//&
-         &                           TRIM(fct_str(il_start(4)))//')'  )
-         CALL logger_debug("count "//TRIM(fct_str(il_count(1)))//','//&
-         &                           TRIM(fct_str(il_count(2)))//','//&
-         &                           TRIM(fct_str(il_count(3)))//','//&
-         &                           TRIM(fct_str(il_count(4)))//')'  )
-         CALL logger_debug("dim "//TRIM(fct_str(td_file%t_dim(1)%i_len))//','//&
-         &                         TRIM(fct_str(td_file%t_dim(2)%i_len))//','//&
-         &                         TRIM(fct_str(td_file%t_dim(3)%i_len))//','//&
-         &                         TRIM(fct_str(td_file%t_dim(4)%i_len))//')'  )
-         CALL logger_debug("shape "//TRIM(fct_str(SIZE(dl_value,DIM=1)))//","//&
-         &                           TRIM(fct_str(SIZE(dl_value,DIM=2)))//","//&
-         &                           TRIM(fct_str(SIZE(dl_value,DIM=3)))//","//&
-         &                           TRIM(fct_str(SIZE(dl_value,DIM=4)))//")" )
-         CALL logger_debug("var "//TRIM(td_var%c_name))
-         il_varid=var_get_id(td_file%t_var(:),TRIM(td_var%c_name))
-         CALL logger_debug("var id "//TRIM(fct_str(il_varid))//' '//TRIM(fct_str(td_var%i_id)))
-         CALL logger_debug("file id "//TRIM(fct_str(td_file%i_id)))
-         il_status = NF90_GET_VAR( td_file%i_id, td_var%i_id,        &
-         &                                       dl_value(:,:,:,:),  &
-         &                                       start = il_start(:),&
-         &                                       count = il_count(:) )
-         CALL iom_cdf__check(il_status)
-
-         ! Allocate space to hold variable value in structure
-         IF( ASSOCIATED(td_var%d_value) )THEN
-            DEALLOCATE(td_var%d_value)   
-         ENDIF
-  
-         ! new dimension length
-         td_var%t_dim(:)%i_len=il_count_ord(:)
-
-         ALLOCATE(td_var%d_value( il_count_ord(1), &
-         &                        il_count_ord(2), &
-         &                        il_count_ord(3), &
-         &                        il_count_ord(4)),&
-         &        stat=il_status)
-         IF(il_status /= 0 )THEN
-
-            CALL logger_error( &
-            &  " READ VAR VALUE: not enough space to put variable "//&
-            &  TRIM(td_var%c_name)//&
-            &  " in variable structure")
-
-         ENDIF
-         ! FillValue by default
-         td_var%d_value(:,:,:,:)=td_var%d_fill
-
-         ! reshape values to be ordered as ('x','y','z','t')
-         tl_dim(:)=td_var%t_dim(:)
-         td_var%d_value(:,:,:,:)=dim_reshape_2xyzt(tl_dim,dl_value(:,:,:,:))
-
-         DEALLOCATE(dl_value)
-
-         ! force to change _FillValue to avoid mistake 
-         ! with dummy zero _FillValue
-         IF( td_var%d_fill == 0._dp )THEN
-            CALL var_chg_FillValue(td_var)
-         ENDIF
+         &  "IOM CDF READ VAR VALUE: no variable "//TRIM(td_var%c_name)//&
+         &  " in file structure "//TRIM(td_file%c_name))
       ENDIF
 
    END SUBROUTINE iom_cdf__read_var_value
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This subroutine write file structure in an opened netcdf file.
    !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf_write_file(td_file)
       IMPLICIT NONE
@@ -1800,14 +1700,14 @@
 
          CALL logger_error( &
-         &  " WRITE FILE: no id associated to file "//TRIM(td_file%c_name))
+         &  " IOM CDF WRITE FILE: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE
          IF( td_file%l_wrt )THEN
 
-            ! delete dummy variable
-            CALL file_del_var( td_file, 'no0d' )
-            CALL file_del_var( td_file, 'no1d' )
-            CALL file_del_var( td_file, 'no2d' )
-            CALL file_del_var( td_file, 'no3d' )
+            ! remove dummy variable
+            CALL file_del_var(td_file,'no0d')
+            CALL file_del_var(td_file,'no1d')
+            CALL file_del_var(td_file,'no2d')
+            CALL file_del_var(td_file,'no3d')
 
             DO ji = 1, td_file%i_nvar
@@ -1816,9 +1716,13 @@
 
             ! save usefull dimension
-            tl_dim(:)=var_max_dim(td_file%t_var(:))
-
-            DO ji=1,ip_maxdim
-               IF( tl_dim(ji)%l_use ) CALL file_move_dim(td_file, tl_dim(ji))
-            ENDDO
+            IF( ASSOCIATED(td_file%t_var) )THEN
+               tl_dim(:)=var_max_dim(td_file%t_var(:))
+
+               DO ji=1,ip_maxdim
+                  IF( tl_dim(ji)%l_use ) CALL file_move_dim(td_file, tl_dim(ji))
+               ENDDO
+               ! clean
+               CALL dim_clean(tl_dim(:))
+            ENDIF
 
             ! write dimension in file
@@ -1836,6 +1740,10 @@
 
                   DEALLOCATE(il_value)
+
+                  ! do not use FillValue for dimension variable
+                  CALL var_del_att(tl_var, "_FillValue")
                    
                   CALL iom_cdf__write_var(td_file,tl_var)
+                  ! clean
                   CALL var_clean(tl_var)
 
@@ -1856,5 +1764,5 @@
 
             CALL logger_error( &
-            &  " WRITE FILE: try to write in file "//TRIM(td_file%c_name)//&
+            &  "IOM CDF WRITE FILE: try to write in file "//TRIM(td_file%c_name)//&
             &  ", not opened in write mode")
 
@@ -1863,5 +1771,4 @@
 
    END SUBROUTINE iom_cdf_write_file
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine write one dimension in an opened netcdf 
@@ -1869,10 +1776,9 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[inout] td_dim : dimension structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[inout] td_dim    dimension structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__write_dim(td_file, td_dim)
       IMPLICIT NONE
@@ -1887,6 +1793,6 @@
       IF( .NOT. td_file%l_def )THEN
 
-         CALL logger_debug( &
-         &  " WRITE FILE DIM: Enter define mode, file "//TRIM(td_file%c_name))
+         CALL logger_trace( &
+         &  " IOM CDF WRITE FILE DIM: Enter define mode, file "//TRIM(td_file%c_name))
 
          ! Enter define mode
@@ -1901,6 +1807,6 @@
          IF( td_dim%l_uld )THEN
             ! write unlimited dimension
-            CALL logger_debug( &
-            &  " WRITE FILE DIM: write unlimited dimension "//&
+            CALL logger_trace( &
+            &  "IOM CDF WRITE FILE DIM: write unlimited dimension "//&
             &  TRIM(td_dim%c_name)//" in file "//TRIM(td_file%c_name))
 
@@ -1911,6 +1817,6 @@
          ELSE
             ! write not unlimited dimension
-            CALL logger_debug( &
-            &  " WRITE FILE DIM: write dimension "//TRIM(td_dim%c_name)//&
+            CALL logger_trace( &
+            &  "IOM CDF WRITE FILE DIM: write dimension "//TRIM(td_dim%c_name)//&
             &  " in file "//TRIM(td_file%c_name))
             
@@ -1923,5 +1829,4 @@
 
    END SUBROUTINE iom_cdf__write_dim
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This subroutine write a variable attribute in
@@ -1929,12 +1834,11 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] id_varid : variable id. use NF90_GLOBAL to write global attribute
-   !> in a file
-   !> @param[in] td_att : attribute structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] id_varid     variable id. use NF90_GLOBAL to write 
+   !> global attribute in a file
+   !> @param[in] td_att       attribute structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__write_att(td_file, id_varid, td_att)
       IMPLICIT NONE
@@ -1950,6 +1854,6 @@
       IF( .NOT. td_file%l_def )THEN
 
-         CALL logger_debug( &
-         &  " WRITE FILE ATT: Enter define mode, file "//TRIM(td_file%c_name))
+         CALL logger_trace( &
+         &  "IOM CDF WRITE FILE ATT: Enter define mode, file "//TRIM(td_file%c_name))
 
          ! Enter define mode
@@ -1962,6 +1866,6 @@
 
       !! put attribute value
-      CALL logger_debug( &
-      &  " WRITE FILE ATT: write attribute "//TRIM(td_att%c_name)//&
+      CALL logger_trace( &
+      &  "IOM CDF WRITE FILE ATT: write attribute "//TRIM(td_att%c_name)//&
       &  " of variable "//TRIM(fct_str(id_varid))//&
       &  " in file "//TRIM(td_file%c_name))
@@ -1983,15 +1887,13 @@
 
    END SUBROUTINE iom_cdf__write_att
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine write a variable in an opened netcdf file.</br/>
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[inout] td_var : variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !-------------------------------------------------------------------
+   !> @brief This subroutine write a variable in an opened netcdf file.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[inout] td_var    variable structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__write_var(td_file, td_var)
       IMPLICIT NONE
@@ -2002,10 +1904,14 @@
       ! local variable
       INTEGER(i4) :: il_status
+      LOGICAL     :: ll_chg
+      ! loop indices
+      INTEGER(i4) :: ji
       !----------------------------------------------------------------
 
       IF( .NOT. td_file%l_def )THEN
 
-         CALL logger_debug( &
-         &  " WRITE FILE VAR: Enter define mode, file "//TRIM(td_file%c_name))
+         CALL logger_trace( &
+         &  " IOM CDF WRITE VAR: Enter define mode, file "//&
+         &  TRIM(td_file%c_name))
 
          ! Enter define mode
@@ -2023,6 +1929,20 @@
          CALL var_check_dim(td_var)
 
-         ! change fill value to NETCDF standard
-         CALL var_chg_FillValue(td_var)
+         ll_chg=.TRUE.
+         DO ji=1,ip_maxdim
+            IF( TRIM(fct_lower(cp_dimorder(ji:ji))) == &
+            &   TRIM(fct_lower(td_var%c_name)) )THEN
+               ll_chg=.FALSE.
+               CALL logger_trace(TRIM(fct_lower(td_var%c_name))//' is var dimension')
+               EXIT
+            ENDIF
+         ENDDO
+         IF( ll_chg )THEN
+            ! not a dimension variable
+            ! change FillValue
+
+            ! ugly patch until NEMO do not force to use 0. as FillValue 
+            CALL var_chg_FillValue(td_var,0._dp)
+         ENDIF
 
          ! define variable in file
@@ -2031,6 +1951,7 @@
          IF( td_file%l_def )THEN
 
-            CALL logger_debug( &
-            &  " WRITE FILE VAR: Leave define mode, file "//TRIM(td_file%c_name))
+            CALL logger_trace( &
+            &  " IOM CDF WRITE VAR: Leave define mode, file "//&
+            &  TRIM(td_file%c_name))
 
             ! Leave define mode
@@ -2050,16 +1971,14 @@
 
    END SUBROUTINE iom_cdf__write_var
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This function define variable in an opened netcdf file.
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] td_var : variable structure
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] td_var    variable structure
    !> @return  variable id
    !-------------------------------------------------------------------
-   !> @code
    INTEGER(i4) FUNCTION iom_cdf__write_var_def(td_file, td_var)
       IMPLICIT NONE
@@ -2070,5 +1989,8 @@
       ! local variable
       INTEGER(i4)                       :: il_status
+      INTEGER(i4)                       :: il_ind
       INTEGER(i4), DIMENSION(ip_maxdim) :: il_dimid
+
+      TYPE(TVAR)                        :: tl_var
 
       ! loop indices
@@ -2077,12 +1999,11 @@
       !----------------------------------------------------------------
 
-      CALL logger_debug( &
-      &  " WRITE FILE VAR DEF: get dimension to be used for variable "//&
-      &  TRIM(td_var%c_name)//" in file "//TRIM(td_file%c_name))
-
-      IF( ALL( .NOT. td_var%t_dim(:)%l_use ) )THEN
+      ! copy structure
+      tl_var=var_copy(td_var)
+
+      IF( ALL( .NOT. tl_var%t_dim(:)%l_use ) )THEN
          ! scalar value
-         il_status = NF90_DEF_VAR(td_file%i_id, TRIM(td_var%c_name), &
-         &                        td_var%i_type, varid=iom_cdf__write_var_def) 
+         il_status = NF90_DEF_VAR(td_file%i_id, TRIM(tl_var%c_name), &
+         &                        tl_var%i_type, varid=iom_cdf__write_var_def) 
          CALL iom_cdf__check(il_status)
       ELSE
@@ -2093,20 +2014,19 @@
          ! reorder dimension, so unused dimension won't be written
          DO ji = 1,  ip_maxdim
-            IF( td_var%t_dim(ji)%l_use )THEN
+            IF( tl_var%t_dim(ji)%l_use )THEN
                jj=jj+1
-               CALL logger_debug(" get dim id for dimension "//TRIM(td_var%t_dim(ji)%c_name))
-               il_dimid(jj)=dim_get_id(td_file%t_dim(:),td_var%t_dim(ji)%c_name)
+               il_dimid(jj)=dim_get_id(td_file%t_dim(:),tl_var%t_dim(ji)%c_name)
             ENDIF
          ENDDO
 
-         CALL logger_debug( &
-         &  " WRITE FILE VAR DEF: define dimension to be used for variable "//&
-         &  TRIM(td_var%c_name)//" in file "//TRIM(td_file%c_name))
+         CALL logger_trace( &
+         &  "IOM CDF WRITE VAR DEF: define dimension to be used for variable "//&
+         &  TRIM(tl_var%c_name)//" in file "//TRIM(td_file%c_name))
 
          DO ji=1,jj
-            CALL logger_debug(" WRITE FILE VAR DEF: dimid "//TRIM(fct_str(il_dimid(ji))) )
+            CALL logger_trace("IOM CDF WRITE VAR DEF: dimid "//TRIM(fct_str(il_dimid(ji))) )
          ENDDO
-         il_status = NF90_DEF_VAR(td_file%i_id, TRIM(td_var%c_name),     &
-         &                        td_var%i_type,                         &
+         il_status = NF90_DEF_VAR(td_file%i_id, TRIM(tl_var%c_name),     &
+         &                        tl_var%i_type,                         &
          &                        il_dimid(1:jj),                        &
          &                        varid=iom_cdf__write_var_def           )
@@ -2114,45 +2034,52 @@
       ENDIF
 
-      DO ji = 1, td_var%i_natt
-         CALL logger_debug( &
-         &  " WRITE FILE VAR DEF: put attribute "//TRIM(td_var%t_att(ji)%c_name)//&
-         &  " for variable "//TRIM(td_var%c_name)//&
+      ! remove unuseful attribute
+      il_ind=att_get_index( tl_var%t_att(:), "ew_overlap" )
+      IF( il_ind /= 0 )THEN
+         IF( tl_var%t_att(il_ind)%d_value(1) == -1 )THEN
+            CALL var_del_att(tl_var, tl_var%t_att(il_ind))
+         ENDIF
+      ENDIF
+
+      DO ji = 1, tl_var%i_natt
+         CALL logger_trace( &
+         &  " IOM CDF WRITE VAR DEF: put attribute "//TRIM(tl_var%t_att(ji)%c_name)//&
+         &  " for variable "//TRIM(tl_var%c_name)//&
          &  " in file "//TRIM(td_file%c_name) )
 
-         IF( td_var%t_att(ji)%i_type == NF90_CHAR )THEN
-            !IF( TRIM(td_var%t_att(ji)%c_value) /= 'unknown' )THEN
-            IF( TRIM(td_var%t_att(ji)%c_value) /= '' )THEN
+         IF( tl_var%t_att(ji)%i_type == NF90_CHAR )THEN
+            IF( TRIM(tl_var%t_att(ji)%c_value) /= '' )THEN
                il_status = NF90_PUT_ATT(td_file%i_id, iom_cdf__write_var_def, &
-               &                        TRIM(td_var%t_att(ji)%c_name),        &
-               &                        TRIM(td_var%t_att(ji)%c_value)        )
+               &                        TRIM(tl_var%t_att(ji)%c_name),        &
+               &                        TRIM(tl_var%t_att(ji)%c_value)        )
                CALL iom_cdf__check(il_status)
             ENDIF
          ELSE
-            SELECT CASE(td_var%t_att(ji)%i_type)
+            SELECT CASE(tl_var%t_att(ji)%i_type)
                CASE(NF90_BYTE)
                   il_status = NF90_PUT_ATT(td_file%i_id,                   &
                   &                        iom_cdf__write_var_def,         &
-                  &                        TRIM(td_var%t_att(ji)%c_name),  &
-                  &                        INT(td_var%t_att(ji)%d_value(:),i1))
+                  &                        TRIM(tl_var%t_att(ji)%c_name),  &
+                  &                        INT(tl_var%t_att(ji)%d_value(:),i1))
                CASE(NF90_SHORT)
                   il_status = NF90_PUT_ATT(td_file%i_id,                   &
                   &                        iom_cdf__write_var_def,         &
-                  &                        TRIM(td_var%t_att(ji)%c_name),  &
-                  &                        INT(td_var%t_att(ji)%d_value(:),i2))
+                  &                        TRIM(tl_var%t_att(ji)%c_name),  &
+                  &                        INT(tl_var%t_att(ji)%d_value(:),i2))
                CASE(NF90_INT)
                   il_status = NF90_PUT_ATT(td_file%i_id,                   &
                   &                        iom_cdf__write_var_def,         &
-                  &                        TRIM(td_var%t_att(ji)%c_name),  &
-                  &                        INT(td_var%t_att(ji)%d_value(:),i4))
+                  &                        TRIM(tl_var%t_att(ji)%c_name),  &
+                  &                        INT(tl_var%t_att(ji)%d_value(:),i4))
                CASE(NF90_FLOAT)
                   il_status = NF90_PUT_ATT(td_file%i_id,                   &
                   &                        iom_cdf__write_var_def,         &
-                  &                        TRIM(td_var%t_att(ji)%c_name),  &
-                  &                        REAL(td_var%t_att(ji)%d_value(:),sp))
+                  &                        TRIM(tl_var%t_att(ji)%c_name),  &
+                  &                        REAL(tl_var%t_att(ji)%d_value(:),sp))
                CASE(NF90_DOUBLE)
                   il_status = NF90_PUT_ATT(td_file%i_id,                   &
                   &                        iom_cdf__write_var_def,         &
-                  &                        TRIM(td_var%t_att(ji)%c_name),  &
-                  &                        REAL(td_var%t_att(ji)%d_value(:),dp))
+                  &                        TRIM(tl_var%t_att(ji)%c_name),  &
+                  &                        REAL(tl_var%t_att(ji)%d_value(:),dp))
                END SELECT
             CALL iom_cdf__check(il_status)
@@ -2161,5 +2088,4 @@
 
    END FUNCTION iom_cdf__write_var_def
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine put variable value in an opened netcdf file.
@@ -2167,14 +2093,13 @@
    !> @details
    !> The variable is written in the type define in variable structure.
-   !> Only dimension used are printed, and fillValue in table are
+   !> Only dimension used are printed, and fillValue in array are
    !> replaced by default fill values defined in module netcdf for each type. 
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] td_var : variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] td_var    variable structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__write_var_value(td_file, td_var)
       IMPLICIT NONE
@@ -2194,6 +2119,6 @@
 
       ! check which dimension use
-      CALL logger_debug( &
-      &  " WRITE FILE VAR VALUE: get dimension to be used for variable "//&
+      CALL logger_trace( &
+      &  "IOM CDF WRITE VAR VALUE: get dimension to be used for variable "//&
       &  TRIM(td_var%c_name)//" in file "//TRIM(td_file%c_name))
 
@@ -2202,6 +2127,4 @@
          IF( td_var%t_dim(ji)%l_use )THEN
             jj=jj+1
-            !il_order(ji)=jj
-            !il_shape(ji)=td_var%t_dim(jj)%i_len
             il_order(jj)=ji
             il_shape(jj)=td_var%t_dim(ji)%i_len
